## pacparser 1.4.6

=== Makefile ===
# Copyright (C) 2024 Manu Garg.
# Author: Manu Garg <manugarg@gmail.com>
#
# Makefile for pacparser docker image.
-include version.mk

VERSION ?= $(shell git describe --always --tags --candidate=100)

GIT_TAG := $(shell git describe --exact-match --exclude tip --tags HEAD 2>/dev/null || /bin/true)
GIT_COMMIT = $(strip $(shell git rev-parse --short HEAD))

DOCKER_IMAGE ?= manugarg/pactester
ifeq "$(GIT_TAG)" ""
	DOCKER_TAGS := -t $(DOCKER_IMAGE):master -t $(DOCKER_IMAGE):main
else
	DOCKER_TAGS := -t $(DOCKER_IMAGE):$(GIT_TAG) -t $(DOCKER_IMAGE):latest
endif

docker_multiarch: Dockerfile
	docker buildx build --push \
		--build-arg BUILD_DATE=`date -u +"%Y-%m-%dT%H:%M:%SZ"` \
		--build-arg VERSION=$(VERSION) \
		--build-arg VCS_REF=$(GIT_COMMIT) \
		--platform linux/amd64,linux/arm64,linux/arm/v7 \
		$(DOCKER_TAGS) .

=== src/Makefile ===
# Copyright (C) 2007 Manu Garg.
# Author: Manu Garg <manugarg@gmail.com>
#
# Makefile for pacparser. Please read README file included with this package
# for more information about pacparser.
#
# pacparser is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 3 of the License, or (at your option) any later version.

# pacparser is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

# This file is not part of the source code repository. It's generated by the
# packaging script.
-include version.mk

ifeq ($(shell uname),FreeBSD)
SHELL := /usr/local/bin/bash
else
SHELL := /bin/bash
endif

VERSION ?= $(shell git describe --always --tags --candidate=100)

GIT_TAG := $(shell git describe --exact-match --exclude tip --tags HEAD 2>/dev/null || /bin/true)

OS_ARCH := $(subst /,_,$(shell uname -s | sed /\ /s//_/))

LIBRARY_NAME = libpacparser
LIB_VER = 1

# This Makefile should at least work on Linux and Mac OS X. It should work on
# most other types of Unix systems too, but I have not put any conscious effort
# for that.
#
# Set variables according to Linux.
SO_SUFFIX = so
LIBRARY = $(LIBRARY_NAME).$(SO_SUFFIX).$(LIB_VER)
MKSHLIB = $(CC) -shared
LIB_OPTS = -Wl,-soname=$(LIBRARY) -Wl,-exclude-libs=libjs.a
SHFLAGS = -fPIC
SMCFLAGS = -DHAVE_VA_COPY -DVA_COPY=va_copy

ifeq ($(OS_ARCH),FreeBSD)
	PREFIX ?= /usr/local
endif

ifeq ($(OS_ARCH),Darwin)
  PREFIX ?= /usr/local
  MAC_MAJOR_VERSION := $(shell sw_vers -productVersion | cut -d. -f1)
  MAC_GT_OS11 := $(shell [ $(MAC_MAJOR_VERSION) -le 10 ] && echo false)
  SO_SUFFIX = dylib
  LIBRARY = $(LIBRARY_NAME).$(LIB_VER).$(SO_SUFFIX)
  MKSHLIB = $(CC) -dynamiclib -framework System
  LIB_OPTS = -install_name $(PREFIX)/lib/$(notdir $@)
  SHFLAGS =
  ifeq ($(MAC_GT_OS11),false)
    MAC_MINOR_VERSION := $(shell sw_vers -productVersion | cut -d. -f2)
    MAC_GT_10_5 := $(shell [ $(MAC_MINOR_VERSION) -le 5 ] && echo false)
    ifeq ($(MAC_GT_10_5),false)
      SMCFLAGS =
    endif
  endif
endif

PREFIX ?= /usr
MAINT_CFLAGS := -g -DXP_UNIX -Wall -DVERSION=$(VERSION)

ifndef PYTHON
  PYTHON = python
endif

# Spidermonkey library.
MAINT_CFLAGS += -Ispidermonkey/js/src

LIBRARY_LINK = $(LIBRARY_NAME).$(SO_SUFFIX)
PREFIX := $(DESTDIR)$(PREFIX)
LIB_PREFIX = $(PREFIX)/lib
INC_PREFIX = $(PREFIX)/include
BIN_PREFIX = $(PREFIX)/bin
DOC_PREFIX = $(PREFIX)/share/doc/pacparser
MAN_PREFIX = $(PREFIX)/share/man

.PHONY: clean pymod install-pymod
all: testpactester

jsapi_buildstamp: spidermonkey/js/src
	cd spidermonkey && SMCFLAGS="$(SHFLAGS) $(SMCFLAGS)" $(MAKE) jsapi
	touch jsapi_buildstamp

spidermonkey/libjs.a: spidermonkey/js/src
	cd spidermonkey && SMCFLAGS="$(SHFLAGS) $(SMCFLAGS)" $(MAKE) jslib

pacparser.o: pacparser.c pac_utils.h pacparser.h jsapi_buildstamp
	$(CC) $(MAINT_CFLAGS) $(CFLAGS) $(SHFLAGS) -c pacparser.c -o pacparser.o
	touch pymod/pacparser_o_buildstamp

$(LIBRARY): pacparser.o spidermonkey/libjs.a
	$(MKSHLIB) $(MAINT_CFLAGS) $(CFLAGS) $(LDFLAGS) $(LIB_OPTS) -o $(LIBRARY) pacparser.o spidermonkey/libjs.a -lm

libpacparser.a: pacparser.o spidermonkey/libjs.a
	cp spidermonkey/libjs.a libpacparser.a
	ar rcs libpacparser.a pacparser.o

$(LIBRARY_LINK): $(LIBRARY)
	ln -sf $(LIBRARY) $(LIBRARY_LINK)

pactester: pactester.c pacparser.h libpacparser.a 
	$(CC) $(MAINT_CFLAGS) $(CFLAGS) $(LDFLAGS) pactester.c libpacparser.a -o pactester -lm -L. -I.

testpactester: pactester $(LIBRARY_LINK)
	echo "Running tests for pactester."
	NO_INTERNET=$(NO_INTERNET) ../tests/runtests.sh

docs:
	../tools/generatedocs.sh

install: all
	install -d $(LIB_PREFIX) $(INC_PREFIX) $(BIN_PREFIX)
	install -m 644 $(LIBRARY) $(LIB_PREFIX)/$(LIBRARY)
	ln -sf $(LIBRARY) $(LIB_PREFIX)/$(LIBRARY_LINK)
	install -m 755 pactester $(BIN_PREFIX)/pactester
	install -m 644 pacparser.h $(INC_PREFIX)/pacparser.h
	# install pactester manpages
	install -d $(MAN_PREFIX)/man1/
	(test -d ../docs && install -m 644 ../docs/man/man1/*.1 $(MAN_PREFIX)/man1/) || true
	# install pacparser manpages
	install -d $(MAN_PREFIX)/man3/
	(test -d ../docs && install -m 644 ../docs/man/man3/*.3 $(MAN_PREFIX)/man3/) || true
	# install html docs
	install -d $(DOC_PREFIX)/html/
	(test -d ../docs/html && install -m 644 ../docs/html/* $(DOC_PREFIX)/html/) || true
	# install examples
	install -d $(DOC_PREFIX)/examples/
	(test -d ../examples && install -m 644 ../examples/* $(DOC_PREFIX)/examples/) || true

dist: all
	bindir=pacparser-$(VERSION)-$(DIST_OS_SUFFIX); \
	bindir=$${bindir/-latest/}; \
	PREFIX= $(MAKE) install DESTDIR=$${bindir}; \
	zip -r $${bindir}.zip $${bindir}/.

# Targets to build python module
pymod: pacparser.o pacparser.h spidermonkey/libjs.a
	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py build
	$(PYTHON) ../tests/runtests.py

pymod-dist: pacparser.o pacparser.h spidermonkey/libjs.a
	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py build
	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py dist
	$(PYTHON) ../tests/runtests.py

install-pymod: pymod
	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py install --root="$(DESTDIR)/" $(EXTRA_ARGS)

clean:
	rm -f $(LIBRARY_LINK) $(LIBRARY) pacparser.o pactester pymod/pacparser_o_buildstamp jsapi_buildstamp
	rm -rf dist
	cd pymod && $(PYTHON) setup.py clean --all
	cd spidermonkey && $(MAKE) clean

=== debian/changelog ===
pacparser (1.4.6-1) unstable; urgency=medium

  * New upstream version 1.4.6.
  * d/watch: bump to version 5 format.
  * d/control:
    - Bump Standards-Version to 4.7.2.
    - Remove Rules-Requires-Root.
    - Remove Section from binary.
  * Add d/salsa-ci.yml.
  * d/rules: clean src/libpacparser.a + hardening.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 07 Nov 2025 16:44:19 +0000

=== debian/control ===
Source: pacparser
Section: libs
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
 Andrew Pollock <apollock@debian.org>,
 Yogeswaran Umasankar <yogu@debian.org>,
Homepage: https://github.com/manugarg/pacparser
Vcs-Git: https://salsa.debian.org/python-team/packages/pacparser.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pacparser
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-all-dev,
 python3-setuptools,
Standards-Version: 4.7.2

Package: libpacparser1
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: library to parse proxy auto-config files
 a library to parse proxy auto-config (PAC) files. Proxy auto-config files are
 a vastly used proxy configuration method these days. Web browsers can use a PAC
 file to determine which proxy server to use or whether to go direct for a given
 URL. PAC files are written in JavaScript and can be programmed to return
 different proxy methods (e.g. "PROXY proxy1:port; DIRECT") depending upon URL,
 source IP address, protocol, time of the day etc. PAC files introduce a lot of
 possibilities.
 .
 Needless to say, PAC files are now a widely accepted method for proxy
 configuration management and companies all over are using them in corporate
 environments. Almost all popular web browsers support PAC files. The idea
 behind pacparser is to make it easy to add this PAC file parsing capability to
 any program (C and Python supported right now).
 .
 This package contains the shared library, and pactester, a tool for testing
 PAC files

Package: libpacparser-dev
Section: libdevel
Depends:
 libpacparser1 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 libpacparser1-dev,
Conflicts:
 libpacparser1-dev,
Architecture: any
Description: library to parse proxy auto-config files (development files)
 a library to parse proxy auto-config (PAC) files. Proxy auto-config files are
 a vastly used proxy configuration method these days. Web browsers can use a PAC
 file to determine which proxy server to use or whether to go direct for a given
 URL. PAC files are written in JavaScript and can be programmed to return
 different proxy methods (e.g. "PROXY proxy1:port; DIRECT") depending upon URL,
 source IP address, protocol, time of the day etc. PAC files introduce a lot of
 possibilities.
 .
 Needless to say, PAC files are now a widely accepted method for proxy
 configuration management and companies all over are using them in corporate
 environments. Almost all popular web browsers support PAC files. The idea
 behind pacparser is to make it easy to add this PAC file parsing capability to
 any program (C and Python supported right now).
 .
 This package contains the header files to build against the shared library.

Package: python3-pacparser
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Architecture: any
Description: Python 3 module to parse proxy auto-config files
 a library to parse proxy auto-config (PAC) files. Proxy auto-config files are
 a vastly used proxy configuration method these days. Web browsers can use a PAC
 file to determine which proxy server to use or whether to go direct for a given
 URL. PAC files are written in JavaScript and can be programmed to return
 different proxy methods (e.g. "PROXY proxy1:port; DIRECT") depending upon URL,
 source IP address, protocol, time of the day etc. PAC files introduce a lot of
 possibilities.
 .
 Needless to say, PAC files are now a widely accepted method for proxy
 configuration management and companies all over are using them in corporate
 environments. Almost all popular web browsers support PAC files. The idea
 behind pacparser is to make it easy to add this PAC file parsing capability to
 any program (C and Python supported right now).
 .
 This package contains the Python 3 bindings for the shared library

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

PYVERSIONS = $(shell py3versions -vr)
VERSION=$(DEB_VERSION_EPOCH_UPSTREAM)
export NO_INTERNET=1

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- -C src VERSION=$(VERSION)

override_dh_install:
	$(MAKE) -C src DESTDIR=$(CURDIR)/debian/tmp install
	for py in $(PYVERSIONS); do \
		$(MAKE) -C src DESTDIR=$(CURDIR)/debian/tmp install-pymod \
			PACPARSER_VERSION=$(VERSION) \
			EXTRA_ARGS=--install-layout=deb \
			PYTHON=python$$py; \
	done
	dh_install

override_dh_auto_clean:
	$(MAKE) -C src clean
	rm -f src/spidermonkey/js/src/jsautocfg.h
	rm -rf src/pymod/build
	rm -rf src/pymod/pacparser.egg-info
	rm -f src/libpacparser.a

=== debian/watch ===
Version: 5
Template: Github
Owner: manugarg
Project: pacparser

## pacparser 1.5.0

=== src/Makefile ===
--- 
+++ 
@@ -45,9 +45,8 @@
 SO_SUFFIX = so
 LIBRARY = $(LIBRARY_NAME).$(SO_SUFFIX).$(LIB_VER)
 MKSHLIB = $(CC) -shared
-LIB_OPTS = -Wl,-soname=$(LIBRARY) -Wl,-exclude-libs=libjs.a
+LIB_OPTS = -Wl,-soname=$(LIBRARY) -Wl,-exclude-libs=libquickjs.a
 SHFLAGS = -fPIC
-SMCFLAGS = -DHAVE_VA_COPY -DVA_COPY=va_copy
 
 ifeq ($(OS_ARCH),FreeBSD)
 	PREFIX ?= /usr/local
@@ -62,24 +61,17 @@
   MKSHLIB = $(CC) -dynamiclib -framework System
   LIB_OPTS = -install_name $(PREFIX)/lib/$(notdir $@)
   SHFLAGS =
-  ifeq ($(MAC_GT_OS11),false)
-    MAC_MINOR_VERSION := $(shell sw_vers -productVersion | cut -d. -f2)
-    MAC_GT_10_5 := $(shell [ $(MAC_MINOR_VERSION) -le 5 ] && echo false)
-    ifeq ($(MAC_GT_10_5),false)
-      SMCFLAGS =
-    endif
-  endif
 endif
 
 PREFIX ?= /usr
-MAINT_CFLAGS := -g -DXP_UNIX -Wall -DVERSION=$(VERSION)
+MAINT_CFLAGS := -g -Wall -DVERSION=$(VERSION)
 
 ifndef PYTHON
   PYTHON = python
 endif
 
-# Spidermonkey library.
-MAINT_CFLAGS += -Ispidermonkey/js/src
+# QuickJS library.
+MAINT_CFLAGS += -Iquickjs
 
 LIBRARY_LINK = $(LIBRARY_NAME).$(SO_SUFFIX)
 PREFIX := $(DESTDIR)$(PREFIX)
@@ -92,28 +84,24 @@
 .PHONY: clean pymod install-pymod
 all: testpactester
 
-jsapi_buildstamp: spidermonkey/js/src
-	cd spidermonkey && SMCFLAGS="$(SHFLAGS) $(SMCFLAGS)" $(MAKE) jsapi
-	touch jsapi_buildstamp
+quickjs/libquickjs.a:
+	cd quickjs && $(MAKE) CFLAGS="$(SHFLAGS)"
 
-spidermonkey/libjs.a: spidermonkey/js/src
-	cd spidermonkey && SMCFLAGS="$(SHFLAGS) $(SMCFLAGS)" $(MAKE) jslib
-
-pacparser.o: pacparser.c pac_utils.h pacparser.h jsapi_buildstamp
+pacparser.o: pacparser.c pac_utils.h pacparser.h
 	$(CC) $(MAINT_CFLAGS) $(CFLAGS) $(SHFLAGS) -c pacparser.c -o pacparser.o
 	touch pymod/pacparser_o_buildstamp
 
-$(LIBRARY): pacparser.o spidermonkey/libjs.a
-	$(MKSHLIB) $(MAINT_CFLAGS) $(CFLAGS) $(LDFLAGS) $(LIB_OPTS) -o $(LIBRARY) pacparser.o spidermonkey/libjs.a -lm
+$(LIBRARY): pacparser.o quickjs/libquickjs.a
+	$(MKSHLIB) $(MAINT_CFLAGS) $(CFLAGS) $(LDFLAGS) $(LIB_OPTS) -o $(LIBRARY) pacparser.o quickjs/libquickjs.a -lm
 
-libpacparser.a: pacparser.o spidermonkey/libjs.a
-	cp spidermonkey/libjs.a libpacparser.a
+libpacparser.a: pacparser.o quickjs/libquickjs.a
+	cp quickjs/libquickjs.a libpacparser.a
 	ar rcs libpacparser.a pacparser.o
 
 $(LIBRARY_LINK): $(LIBRARY)
 	ln -sf $(LIBRARY) $(LIBRARY_LINK)
 
-pactester: pactester.c pacparser.h libpacparser.a 
+pactester: pactester.c pacparser.h libpacparser.a
 	$(CC) $(MAINT_CFLAGS) $(CFLAGS) $(LDFLAGS) pactester.c libpacparser.a -o pactester -lm -L. -I.
 
 testpactester: pactester $(LIBRARY_LINK)
@@ -149,11 +137,11 @@
 	zip -r $${bindir}.zip $${bindir}/.
 
 # Targets to build python module
-pymod: pacparser.o pacparser.h spidermonkey/libjs.a
+pymod: pacparser.o pacparser.h quickjs/libquickjs.a
 	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py build
 	$(PYTHON) ../tests/runtests.py
 
-pymod-dist: pacparser.o pacparser.h spidermonkey/libjs.a
+pymod-dist: pacparser.o pacparser.h quickjs/libquickjs.a
 	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py build
 	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py dist
 	$(PYTHON) ../tests/runtests.py
@@ -162,7 +150,7 @@
 	cd pymod && ARCHFLAGS="" $(PYTHON) setup.py install --root="$(DESTDIR)/" $(EXTRA_ARGS)
 
 clean:
-	rm -f $(LIBRARY_LINK) $(LIBRARY) pacparser.o pactester pymod/pacparser_o_buildstamp jsapi_buildstamp
+	rm -f $(LIBRARY_LINK) $(LIBRARY) pacparser.o pactester pymod/pacparser_o_buildstamp libpacparser.a
 	rm -rf dist
 	cd pymod && $(PYTHON) setup.py clean --all
-	cd spidermonkey && $(MAKE) clean
+	cd quickjs && $(MAKE) clean

=== src/quickjs/Makefile ===
CFLAGS += -fPIC
libquickjs.a: quickjs.o
	ar rcs $@ $<
quickjs.o: quickjs.c quickjs.h
	$(CC) $(CFLAGS) -c quickjs.c -o quickjs.o
clean:
	rm -f quickjs.o libquickjs.a

=== debian/changelog ===
pacparser (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0.
  * d/patches:
    - Update 001_py3only.patch.
    - Remove 003_fix-for-spidermonkey-issues.patch.
    - Remove 004_fix-GCC14-va.patch.
  * d/copyright:
    - Update copyrights for new upstream version.
    - Add copyright for debian/*.
  * d/control:
    - Bump Standards-Version to 4.7.3.
    - Remove Priority.
  * d/rules: remove spidermonkey related line.
  * Add d/upstream/metadata.

 -- Yogeswaran Umasankar <yogu@debian.org>  Fri, 13 Feb 2026 03:15:25 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: pacparser
 Section: libs
-Priority: optional
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders:
  Alexandre Detiste <tchet@debian.org>,
@@ -14,7 +13,7 @@
  dh-sequence-python3,
  python3-all-dev,
  python3-setuptools,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 
 Package: libpacparser1
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -27,7 +27,6 @@
 
 override_dh_auto_clean:
 	$(MAKE) -C src clean
-	rm -f src/spidermonkey/js/src/jsautocfg.h
 	rm -rf src/pymod/build
 	rm -rf src/pymod/pacparser.egg-info
 	rm -f src/libpacparser.a
